import org.apache.axis.AxisFault;
import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.axis.encoding.XMLType;
import org.apache.axis.encoding.ser.JAFDataHandlerDeserializerFactory;
import org.apache.axis.encoding.ser.JAFDataHandlerSerializerFactory;

import javax.activation.DataHandler;
import javax.activation.FileDataSource;
import javax.xml.namespace.QName;
import javax.xml.rpc.ParameterMode;
import java.net.URL;
import java.io.*;

//javac -classpath .:/usr/local/cog-4_1_4/lib/axis.jar:/usr/local/cog-4_1_4/lib/activation.jar:/usr/local/cog-4_1_4/lib/jaxrpc.jar Client.java
//java -classpath .:/usr/local/cog-4_1_4/lib/axis.jar:/usr/local/cog-4_1_4/lib/activation.jar:/usr/local/cog-4_1_4/lib/jaxrpc.jar:/usr/local/cog-4_1_4/lib/commons-logging-1.0.4.jar:/usr/local/cog-4_1_4/lib/commons-discovery.jar:/usr/local/cog-4_1_4/lib/mail.jar:/usr/local/cog-4_1_4/lib/wsdl4j.jar Client
//a=system("java -classpath /home/malte/.eclipse/GridRWebservice/src:/usr/local/cog-4_1_4/lib/axis.jar:/usr/local/cog-4_1_4/lib/activation.jar:/usr/local/cog-4_1_4/lib/jaxrpc.jar:/usr/local/cog-4_1_4/lib/commons-logging-1.0.4.jar:/usr/local/cog-4_1_4/lib/commons-discovery.jar:/usr/local/cog-4_1_4/lib/mail.jar:/usr/local/cog-4_1_4/lib/wsdl4j.jar Client", intern=TRUE)
public class Client {

	public static void main(String[] args) {
		if (args.length == 4)
			System.out.println(contactWS(args[0], args[1], args[2], args[3],
					null, null, null, null, null));
		else if (args.length == 8)
			System.out.println(contactWS(args[0], args[1], args[2], args[3],
					args[4], args[5], args[6], args[7], null));
		else if (args.length == 9)
			System.out.println(contactWS(args[0], args[1], args[2], args[3],
					args[4], args[5], args[6], args[7], args[8]));
		else
			System.out
					.println("Wrong usage of the Client: type of webservice, WShost, rCodeToEcecute, "
							+ "libFile, [GlobusExecutionHost, myProxyHost, MyProxyUsername, pwd, [inputDir]]\n");
	}

	public static String contactWS(String webservice, String WShost,
			String FileRCodeToExecute, String libFile, String executionHost,
			String myProxyHost, String username, String pwd, String inputDir) {

		Object ret = null; // return of WS
		DataHandler localLibFile = null;
		DataHandler rCode = null;

		// Create the data for the attached file.
		try {
			localLibFile = new DataHandler(new FileDataSource(libFile));
		} catch (Exception e) {
			return ("cannot open File" + libFile);
		}
		try {
			rCode = new DataHandler(new FileDataSource(FileRCodeToExecute));
		} catch (Exception e) {
			return ("cannot open File" + FileRCodeToExecute);
		}

		try {
			Service service = new Service();
			Call call = (Call) service.createCall();
			call.setTargetEndpointAddress(new URL(WShost)); // Set the target
															// service host and
															// service location,
			call
					.setOperationName(new QName("urn:" + webservice,
							"executeGridR")); // This is the target services
												// method to invoke.

			QName qnameAttachment = new QName("urn:" + webservice,
					"DataHandler");
			call.registerTypeMapping(
					localLibFile.getClass(), // Add serializer for attachment
												// 1.
					qnameAttachment, JAFDataHandlerSerializerFactory.class,
					JAFDataHandlerDeserializerFactory.class);
			call.registerTypeMapping(
					rCode.getClass(), // Add serializer for attachment 2.
					qnameAttachment, JAFDataHandlerSerializerFactory.class,
					JAFDataHandlerDeserializerFactory.class);

			call.addParameter("RCode", qnameAttachment, ParameterMode.IN);
			call
					.addParameter("localLibFile", qnameAttachment,
							ParameterMode.IN); // Add the file.
			call.setReturnType(XMLType.XSD_ANY);

			// add the other variables only if connect to GlobusWS
			if (webservice.equals("GlobusRWebservice")) {
				call.addParameter("executionHost",
						org.apache.axis.Constants.XSD_STRING, ParameterMode.IN);
				call.addParameter("myProxyHost",
						org.apache.axis.Constants.XSD_STRING, ParameterMode.IN);
				call.addParameter("username",
						org.apache.axis.Constants.XSD_STRING, ParameterMode.IN);
				call.addParameter("pwd", org.apache.axis.Constants.XSD_STRING,
						ParameterMode.IN);
				call.addParameter("inputDir",
						org.apache.axis.Constants.XSD_STRING, ParameterMode.IN);

				ret = call.invoke(new Object[] { rCode, localLibFile,
						executionHost, myProxyHost, username, pwd, inputDir });
			} else
				ret = call.invoke(new Object[] { rCode, localLibFile });
		} catch (Exception e) {
			e.printStackTrace();
			return ("Cannot connect to webservice\n" + e.getMessage());
		}

		// call.setUsername(opts.getUser());
		// call.setPassword(opts.getPassword());

		if (null == ret) {
			System.out.println("Received null ");
			return ("Received null return of WS");
		}
		/*
		 * alt Vector vret = (Vector) ret;
		 * 
		 * if(vret.size()==1) //only one element in the return vector return
		 * (String) vret.firstElement(); else
		 * 
		 * return vret.toString(); }
		 */

		// copy Data from DataHandler to File
		/*
		 * InputStream fis=null; File dResult=null; FileOutputStream fos=null;
		 * 
		 * try{ DataHandler dhRet = (DataHandler) ret; fis =
		 * dhRet.getInputStream(); dResult = new File("/tmp/testOutR"); fos =
		 * new FileOutputStream(dResult); byte buffer[] = new byte[0xffff]; int
		 * nbytes;
		 * 
		 * while ( (nbytes = fis.read(buffer)) >= 0 ) fos.write( buffer, 0,
		 * nbytes ); } catch( IOException e ) { System.err.println( e ); }
		 * finally { if ( fis != null ) try { fis.close(); } catch ( IOException
		 * e ) {}
		 * 
		 * try { if ( fos != null ) fos.close(); } catch ( IOException e ) {} }
		 * 
		 * return dResult.getAbsolutePath();
		 */

		DataHandler dhRet = (DataHandler) ret;
		File f = new File(dhRet.getName());
		// f.deleteOnExit();
		return f.getAbsolutePath();
	}

	/*
	 * public static String upload(String filename, String url, String userName,
	 * String pw, String webservice) throws Exception {
	 * 
	 * //javax.activation.MimetypesFileTypeMap map=
	 * (javax.activation.MimetypesFileTypeMap)javax.activation.MimetypesFileTypeMap.getDefaultFileTypeMap();
	 * //map.addMimeTypes("application/x-org-apache-axis-wsdd wsdd");
	 * 
	 * final boolean doTheDIME=false; //Create the data for the attached file.
	 * DataHandler dhSource = new DataHandler(new FileDataSource(filename));
	 * 
	 * Service service = new Service();
	 * 
	 * Call call = (Call) service.createCall();
	 * 
	 * 
	 * call.setTargetEndpointAddress(new URL(url)); //Set the target service
	 * host and service location,
	 * 
	 * call.setOperationName(new QName("urn:"+webservice, "uploadFile")); //This
	 * is the target services method to invoke.
	 * 
	 * QName qnameAttachment = new QName("urn:"+webservice, "DataHandler");
	 * 
	 * call.registerTypeMapping(dhSource.getClass(), //Add serializer for
	 * attachment. qnameAttachment, JAFDataHandlerSerializerFactory.class,
	 * JAFDataHandlerDeserializerFactory.class);
	 * 
	 * 
	 * call.addParameter("dhSource", qnameAttachment, ParameterMode.IN); //Add
	 * the file. call.addParameter("userName",
	 * org.apache.axis.Constants.XSD_STRING, ParameterMode.IN);
	 * call.addParameter("pw", org.apache.axis.Constants.XSD_STRING,
	 * ParameterMode.IN);
	 * 
	 * call.setReturnType(XMLType.XSD_STRING);
	 *  // call.setUsername(opts.getUser());
	 *  // call.setPassword(opts.getPassword());
	 * 
	 * if (doTheDIME) call.setProperty(call.ATTACHMENT_ENCAPSULATION_FORMAT,
	 * call.ATTACHMENT_ENCAPSULATION_FORMAT_DIME);
	 * 
	 * 
	 * Object ret = call.invoke(new Object[]{ dhSource, userName, pw } ); //Add
	 * the attachment.
	 * 
	 * if (null == ret) { System.out.println("Received null "); throw new
	 * AxisFault("", "Received null", null, null); }
	 * 
	 * String sRet = (String) ret; return sRet; }
	 */

}
